%bcond_without perl_Inline_enables_optional_test

Name:           perl-Inline
Version:        0.86
Release:    1%{?dist}
Summary:        Inline Perl module
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
Url:            https://metacpan.org/release/Inline
Source0:        https://cpan.metacpan.org/authors/id/I/IN/INGY/Inline-%{version}.tar.gz
BuildArch:      noarch
BuildRequires:  coreutils
BuildRequires:  findutils
BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(:VERSION) >= 5.8.1
BuildRequires:  perl(Config)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(File::Find)
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
BuildRequires:  perl(base)
BuildRequires:  perl(Carp)
BuildRequires:  perl(Cwd)
BuildRequires:  perl(Digest::MD5)
BuildRequires:  perl(DynaLoader)
BuildRequires:  perl(Encode)
BuildRequires:  perl(Exporter)
BuildRequires:  perl(Fcntl)
BuildRequires:  perl(File::Spec) >= 0.80
BuildRequires:  perl(File::Spec::Unix)
BuildRequires:  perl(FindBin)
BuildRequires:  perl(Socket)
BuildRequires:  perl(utf8)
BuildRequires:  perl(version) >= 0.82
BuildRequires:  perl(File::Path)
BuildRequires:  perl(File::Spec::Functions)
BuildRequires:  perl(Inline::Files)
BuildRequires:  perl(lib)
BuildRequires:  perl(TestML::Bridge)
BuildRequires:  perl(TestML::Run::TAP)
BuildRequires:  perl(Test::More)
BuildRequires:  perl(Test::Warn) >= 0.23
%if %{with perl_Inline_enables_optional_test}
BuildRequires:  perl(diagnostics)
%endif
Requires:       perl(Digest::MD5)
Requires:       perl(DynaLoader)
Requires:       perl(File::Spec) >= 0.80
Requires:       perl(FindBin)
Requires:       perl(Socket)
Requires:       perl(version) >= 0.82

%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\((File::Spec|version)\\)$
%global __provides_exclude %{?__provides_exclude:%{__provides_exclude}|}^perl\\(Inline\\)$
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\((TestInlineSetup|TestML::Bridge)\\)$
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}

%description
The Inline module allows you to put source code from other programming
languages directly "inline" in a Perl script or module. The code is
automatically compiled as needed, and then loaded for immediate access
from Perl.

Inline saves you from the hassle of having to write and compile your
own glue code using facilities like XS or SWIG. Simply type the code
where you want it and run your Perl as normal. All the hairy details
are handled for you. The compilation and installation of your code
chunks all happen transparently; all you will notice is the delay of
compilation on the first run.

The Inline code only gets compiled the first time you run it (or
whenever it is modified) so you only take the performance hit
once. Code that is Inlined into distributed modules (like on the CPAN)
will get compiled when the module is installed, so the end user will
never notice the compilation time.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       perl-Test-Harness

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%prep
%setup -q -n Inline-%{version}
find example -type f -exec chmod 0644 {} +
rm -rf inc/lib
perl -i -ne 'print $_ unless m{^inc/lib/}' MANIFEST
for F in t/*.t; do
    if [ "$F" != "t/03errors.t" ] && [ "$F" != "t/09perl5lib.t" ]; then
        perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!\s*perl}{$Config{startperl}}' "$F"
    fi
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
rm -f %{buildroot}%{_libexecdir}/%{name}/t/000*
rm -f %{buildroot}%{_libexecdir}/%{name}/t/author-pod-syntax.t
rm -f %{buildroot}%{_libexecdir}/%{name}/t/03errors.t
rm -f %{buildroot}%{_libexecdir}/%{name}/t/09perl5lib.t
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
unset PERL_INLINE_DIRECTORY PERL5LIB PERL5OPT
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test
%{_fixperms} %{buildroot}/*

%check
unset AUTHOR_TESTING PERL_INLINE_DIRECTORY PERL5LIB PERL5OPT
make test

%files
%license LICENSE
%doc Changes CONTRIBUTING example README
%{perl_vendorlib}/Inline*
%{_mandir}/man3/*.3*

%files tests
%{_libexecdir}/%{name}

%changelog
* Thu Jun 20 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.86-1
- initial build
